﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Collections.Generic;
using RTedge;
namespace EgMDiag
{
    public class Diag
    {
        private EdgeService EGS = EdgeService.GetInstance();// RT-edgeのコード
        private edge_API.MDiagDeviceMgr dev = new edge_API.MDiagDeviceMgr();                  // デバイスマネージャの情報取得クラス

        /// <summary>
        /// Gatherクラスの初期化
        /// </summary>
        public Diag()
        {
            //何かあれば
        }
        /// <summary>
        /// パフォーマンスカウンタ値取得 API呼び出し
        /// </summary>
        /// <param name="PCounter"></param>
        /// <param name="refValue"></param>
        /// <returns></returns>
        public bool GetPerformanceCounterOne(string PCounterName_All, ref float refValue)
        {
            try
            {
                int ret = EGS.EGAPI.EgMDiagExecute_PfmCntGet(PCounterName_All, ref refValue);
                if (ret != 0)
                    return false;
                return true;
            }
            catch (Exception ex)
            {
                EGS.PrintLog("ERR", "FATAL ERROR : {0}", System.Reflection.MethodBase.GetCurrentMethod().Name + " : " + ex.Message);
                return false;
            }

        }
        
        /// <summary>
        /// デバイス情報エラー数取得
        /// </summary>
        /// <param name="erroutputed"></param>
        /// <param name="errcount"></param>
        /// <returns></returns>
        public bool GetAccError(bool erroutputed, ref int errcount)
        {
            bool bRet = false;              //戻り値
            try
            {
                //エラーが詰まってくるリストを作成
                List<edge_API.MDiagDeviceMgr.DevErrST> err_List = new List<edge_API.MDiagDeviceMgr.DevErrST>();
                bRet = dev.GetDiEnumDeviceInfoErr(ref err_List);
                //エラーを出力する フラグは見ない　必ず出力する
                if ( err_List.Count > 0 /* && erroutputed == false */)
                {
                    errcount = err_List.Count;
                    foreach (edge_API.MDiagDeviceMgr.DevErrST errST in err_List)
                        EGS.PrintLog("ERR", "{0}", errST.ErrMessage);
                }
                return bRet;
            }
            catch (Exception ex)
            {
                EGS.PrintLog("ERR", "FATAL ERROR : {0}", System.Reflection.MethodBase.GetCurrentMethod().Name + " : " + ex.Message);
                return bRet;
            }
        }
    }
}
