﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using RTedge;

namespace EgMDiag
{
    public partial class EdgeService
    {
        //タグの定義
        public MntTagCls ServiceIndRun = null;　     // インジケータタグ".Run" : bool / Service Run indicator
        public MntTagCls ServiceIndStatus = null;　  // インジケータタグ".Status" : byte / Service Status indicator
        public MntTagCls ServiceIndError = null;　   // インジケータタグ".Error" : bool / Service Error indicator
        public MntTagCls ServiceIndLive = null;　    // インジケータタグ".Live" : UInt32 / Service Live counter indicator

        /// <summary>
        /// システムタグ EDGESYSTEM.XXXX.Status 正常・異常判定値
        /// </summary>
        public MntTagCls CpuUse_Status = null;//システムタグ EDGESYSTEM.CpuUse.Status
        public MntTagCls MemUse_Status = null;//システムタグ EDGESYSTEM.MemUse.Status
        public MntTagCls OperatingTime_Status = null;//システムタグ EDGESYSTEM.OperatingTime.Status
        public MntTagCls AccErr_Status = null;//システムタグ EDGESYSTEM.AccErr.Status

        public MntTagCls DiskSpace_A_Status = null;//システムタグ EDGESYSTEM.DiskSpace_A_Status
        public MntTagCls DiskSpace_B_Status = null;//システムタグ EDGESYSTEM.DiskSpace_B_Status
        public MntTagCls DiskSpace_C_Status = null;//システムタグ EDGESYSTEM.DiskSpace_C_Status
        public MntTagCls DiskSpace_D_Status = null;//システムタグ EDGESYSTEM.DiskSpace_D_Status
        public MntTagCls DiskSpace_E_Status = null;//システムタグ EDGESYSTEM.DiskSpace_E_Status
        public MntTagCls DiskSpace_F_Status = null;//システムタグ EDGESYSTEM.DiskSpace_F_Status
        public MntTagCls DiskSpace_G_Status = null;//システムタグ EDGESYSTEM.DiskSpace_G_Status
        public MntTagCls DiskSpace_H_Status = null;//システムタグ EDGESYSTEM.DiskSpace_H_Status
        public MntTagCls DiskSpace_I_Status = null;//システムタグ EDGESYSTEM.DiskSpace_I_Status
        public MntTagCls DiskSpace_J_Status = null;//システムタグ EDGESYSTEM.DiskSpace_J_Status
        public MntTagCls DiskSpace_K_Status = null;//システムタグ EDGESYSTEM.DiskSpace_K_Status
        public MntTagCls DiskSpace_L_Status = null;//システムタグ EDGESYSTEM.DiskSpace_L_Status
        public MntTagCls DiskSpace_M_Status = null;//システムタグ EDGESYSTEM.DiskSpace_M_Status
        public MntTagCls DiskSpace_N_Status = null;//システムタグ EDGESYSTEM.DiskSpace_N_Status
        public MntTagCls DiskSpace_O_Status = null;//システムタグ EDGESYSTEM.DiskSpace_O_Status
        public MntTagCls DiskSpace_P_Status = null;//システムタグ EDGESYSTEM.DiskSpace_P_Status
        public MntTagCls DiskSpace_Q_Status = null;//システムタグ EDGESYSTEM.DiskSpace_Q_Status
        public MntTagCls DiskSpace_R_Status = null;//システムタグ EDGESYSTEM.DiskSpace_R_Status
        public MntTagCls DiskSpace_S_Status = null;//システムタグ EDGESYSTEM.DiskSpace_S_Status
        public MntTagCls DiskSpace_T_Status = null;//システムタグ EDGESYSTEM.DiskSpace_T_Status
        public MntTagCls DiskSpace_U_Status = null;//システムタグ EDGESYSTEM.DiskSpace_U_Status
        public MntTagCls DiskSpace_V_Status = null;//システムタグ EDGESYSTEM.DiskSpace_V_Status
        public MntTagCls DiskSpace_W_Status = null;//システムタグ EDGESYSTEM.DiskSpace_W_Status
        public MntTagCls DiskSpace_X_Status = null;//システムタグ EDGESYSTEM.DiskSpace_X_Status
        public MntTagCls DiskSpace_Y_Status = null;//システムタグ EDGESYSTEM.DiskSpace_Y_Status
        public MntTagCls DiskSpace_Z_Status = null;//システムタグ EDGESYSTEM.DiskSpace_Z_Status

        
        /// <summary>
        /// プロパティタグ
        /// </summary>
        public MntTagCls Cycle = null;               // プロパティタグ".Cycle" : UInt32 診断機能用 診断周期(秒)
        public MntTagCls AutoRun = null;             // プロパティタグ".AutoRun" : bool 動作自動スタートの有効有無
        public MntTagCls Error = null;               // インジケータタグ".Error" : bool エラー状態の有効有無
        public MntTagCls ErrorID = null;             // インジケータタグ".ErrorID" UInt32 実行失敗時のエラーコード
        public MntTagCls ExecuteCnt = null;          // 統計情報タグ".ExecuteCnt" UInt32 実行数
        public MntTagCls ThreadCnt = null;           // 統計情報タグ

        public TagPropTHCls Diag_CpuUseTH = null;    // プロパティタグ".CpuUseTH" : Float CPU使用率 閾値 (%)
        public TagPropTHCls Diag_MemUseTH = null;    // プロパティタグ".MemUseTH" : Float メモリ使用量 閾値 (MB)
        public TagPropTHCls Diag_OpeTimeTH = null;   // プロパティタグ".OpeTimeTH" : UInt64 システム稼働時間 閾値 (秒)
        public TagPropTHCls Diag_AccErrTH = null;    // プロパティタグ".AccErrTH" : UInt32 周辺機器エラー数 閾値 (個)

        public MntTagCls Cycle_SMART = null;         // プロパティタグ".Cycle_SMART" : UInt32 診断機能用 診断周期(秒)(S.M.A.R.T.用)

        /// <summary>
        /// プロパティタグ SERVICE.EgMDiag.DiskSpace_{Drive}_TH ディスク空き容量
        /// </summary>
        TagPropTHCls Diag_DiskSpace_A_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_A_TH
        TagPropTHCls Diag_DiskSpace_B_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_B_TH
        TagPropTHCls Diag_DiskSpace_C_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_C_TH
        TagPropTHCls Diag_DiskSpace_D_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_D_TH
        TagPropTHCls Diag_DiskSpace_E_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_E_TH
        TagPropTHCls Diag_DiskSpace_F_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_F_TH
        TagPropTHCls Diag_DiskSpace_G_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_G_TH
        TagPropTHCls Diag_DiskSpace_H_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_H_TH
        TagPropTHCls Diag_DiskSpace_I_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_I_TH
        TagPropTHCls Diag_DiskSpace_J_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_J_TH
        TagPropTHCls Diag_DiskSpace_K_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_K_TH
        TagPropTHCls Diag_DiskSpace_L_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_L_TH
        TagPropTHCls Diag_DiskSpace_M_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_M_TH
        TagPropTHCls Diag_DiskSpace_N_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_N_TH
        TagPropTHCls Diag_DiskSpace_O_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_O_TH
        TagPropTHCls Diag_DiskSpace_P_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_P_TH
        TagPropTHCls Diag_DiskSpace_Q_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_Q_TH
        TagPropTHCls Diag_DiskSpace_R_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_R_TH
        TagPropTHCls Diag_DiskSpace_S_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_S_TH
        TagPropTHCls Diag_DiskSpace_T_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_T_TH
        TagPropTHCls Diag_DiskSpace_U_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_U_TH
        TagPropTHCls Diag_DiskSpace_V_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_V_TH
        TagPropTHCls Diag_DiskSpace_W_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_W_TH
        TagPropTHCls Diag_DiskSpace_X_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_X_TH
        TagPropTHCls Diag_DiskSpace_Y_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_Y_TH
        TagPropTHCls Diag_DiskSpace_Z_TH = null;//プロパティタグ SERVICE.EgMDiag.DiskSpace_Z_TH

        /// <summary>
        /// Tag更新用クラス
        /// </summary>
        public class MntTagCls
        {
            public EGDEFINE.egTagDataType Type = EGDEFINE.egTagDataType.UNDEFINE;   //型
            public string TagName = ""; //Tag名
            //コンストラクタ
            public MntTagCls(string _name, EGDEFINE.egTagDataType _Type)
            {
                TagName = _name;//名前の設定
                Type = _Type;   //型の設定
                InitValue();    //値初期化
            }
            private object _Value = new object();
            public object Value
            {
                set
                {
                    switch (Type)   //型ごとに変換 対応しているのは現状3つの型のみ
                    {
                        case EGDEFINE.egTagDataType.UInt32:
                            _Value = (UInt32)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.UInt64:
                            _Value = (UInt64)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Float:
                            _Value = (float)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Boolean:
                            _Value = (bool)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.SByte:
                            _Value = (SByte)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Byte:
                            _Value = (byte)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Int16:
                            _Value = (Int16)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.UInt16:
                            _Value = (UInt16)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Int32:
                            _Value = (Int32)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Int64:
                            _Value = (Int64)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Double:
                            _Value = (double)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.String:
                            _Value = (string)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        default:
                            break;
                    }
                }
                get { return _Value; }
            }
            /// <summary>
            /// 値の初期化
            /// </summary>
            private void InitValue()
            {
                switch (Type)   //型ごとに変換 対応しているのは現状3つの型のみ
                {
                    case EGDEFINE.egTagDataType.UInt32:
                        _Value = (UInt32)0;
                        break;
                    case EGDEFINE.egTagDataType.UInt64:
                        _Value = (UInt64)0;
                        break;
                    case EGDEFINE.egTagDataType.Float:
                        _Value = (float)0;
                        break;
                    case EGDEFINE.egTagDataType.Boolean:
                        _Value = (bool)false;
                        break;
                    case EGDEFINE.egTagDataType.SByte:
                        _Value = (SByte)0;
                        break;
                    case EGDEFINE.egTagDataType.Byte:
                        _Value = (byte)0;
                        break;
                    case EGDEFINE.egTagDataType.Int16:
                        _Value = (Int16)0;
                        break;
                    case EGDEFINE.egTagDataType.UInt16:
                        _Value = (UInt16)0;
                        break;
                    case EGDEFINE.egTagDataType.Int32:
                        _Value = (Int32)0;
                        break;
                    case EGDEFINE.egTagDataType.Int64:
                        _Value = (Int64)0;
                        break;
                    case EGDEFINE.egTagDataType.Double:
                        _Value = (double)0;
                        break;
                    case EGDEFINE.egTagDataType.String:
                        _Value = (string)"";
                        break;
                    default:
                        break;
                }
            }
        }
        /// <summary>
        /// 閾値 操作用クラス
        /// </summary>
        public class TagPropTHCls
        {
            public string TagName = "";                                              //Tag名
            public EGDEFINE.egTagDataType Type = EGDEFINE.egTagDataType.UNDEFINE;   //型
            public SByte IsTargetIsBig = -1;                                        //比較時  target>value (big) or target<value (small)  == err 
            //コンストラクタ
            public TagPropTHCls(string name) { TagName = name; }
            //コンストラクタ
            public TagPropTHCls(string name, EGDEFINE.egTagDataType egType, SByte sbValue) { TagName = name; Type = egType; IsTargetIsBig = sbValue; }
            private object _Value = new object();
            public object Value
            {
                set
                {
                    switch (Type)   //型ごとに変換 対応しているのは現状3つの型のみ
                    {
                        case EGDEFINE.egTagDataType.UInt32:
                            _Value = (UInt32)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.UInt64:
                            _Value = (UInt64)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Float:
                            _Value = (float)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Boolean:
                            _Value = (bool)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.SByte:
                            _Value = (SByte)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Byte:
                            _Value = (byte)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Int16:
                            _Value = (Int16)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.UInt16:
                            _Value = (UInt16)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Int32:
                            _Value = (Int32)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Int64:
                            _Value = (Int64)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Double:
                            _Value = (double)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.String:
                            _Value = (string)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        default:
                            break;
                    }
                }
                get { return _Value; }
            }
            
            /// <summary>
            /// ターゲットが閾値より大きい場合エラーのチェック
            /// </summary>
            /// <param name="TargetValue"></param>
            /// <returns></returns>
            private SByte CheckTH_Big(object TargetValue)
            {
                switch (Type)
                {
                    case EGDEFINE.egTagDataType.UInt32:
                        {
                            //タイプが一致している場合のチェック
                            if (typeof(UInt32) == TargetValue.GetType())
                            {
                                if ((UInt32)TargetValue > (UInt32)Value) //値が閾値を越えたらエラー
                                    return DIAG_THRESULT_ERR;
                                return DIAG_THRESULT_OK;            //それ以外はOK
                            }
                        }
                        break;
                    case EGDEFINE.egTagDataType.UInt64:
                        //タイプが一致している場合のチェック
                        if (typeof(UInt64) == TargetValue.GetType())
                        {
                            if ((UInt64)TargetValue > (UInt64)Value) //値が閾値を越えたらエラー
                                return DIAG_THRESULT_ERR;
                            return DIAG_THRESULT_OK;            //それ以外はOK
                        }
                        break;
                    case EGDEFINE.egTagDataType.Float:
                        //タイプが一致している場合のチェック
                        if (typeof(float) == TargetValue.GetType())
                        {
                            if ((float)TargetValue > (float)Value) //値が閾値を越えたらエラー
                                return DIAG_THRESULT_ERR;
                            return DIAG_THRESULT_OK;            //それ以外はOK
                        }
                        break;
                    case EGDEFINE.egTagDataType.Boolean:
                    case EGDEFINE.egTagDataType.SByte:
                    case EGDEFINE.egTagDataType.Byte:
                    case EGDEFINE.egTagDataType.Int16:
                    case EGDEFINE.egTagDataType.UInt16:
                    case EGDEFINE.egTagDataType.Int32:
                    case EGDEFINE.egTagDataType.Int64:
                    case EGDEFINE.egTagDataType.Double:
                    case EGDEFINE.egTagDataType.String:
                    default:
                        break;
                }
                return DIAG_THRESULT_NOTCHECK;
            }
            /// <summary>
            /// ターゲットが閾値より小さい場合エラーのチェック
            /// </summary>
            /// <param name="TargetValue"></param>
            /// <returns></returns>
            private SByte CheckTH_Small(object TargetValue)
            {
                switch (Type)
                {
                    case EGDEFINE.egTagDataType.UInt32:
                        {
                            //タイプが一致している場合のチェック
                            if (typeof(UInt32) == TargetValue.GetType())
                            {
                                if ((UInt32)TargetValue < (UInt32)Value) //値が閾値を越えたらエラー
                                    return DIAG_THRESULT_ERR;
                                return DIAG_THRESULT_OK;            //それ以外はOK
                            }
                        }
                        break;
                    case EGDEFINE.egTagDataType.UInt64:
                        //タイプが一致している場合のチェック
                        if (typeof(UInt64) == TargetValue.GetType())
                        {
                            if ((UInt64)TargetValue < (UInt64)Value) //値が閾値を越えたらエラー
                                return DIAG_THRESULT_ERR;
                            return DIAG_THRESULT_OK;            //それ以外はOK
                        }
                        break;
                    case EGDEFINE.egTagDataType.Float:
                        //タイプが一致している場合のチェック
                        if (typeof(float) == TargetValue.GetType())
                        {
                            if ((float)TargetValue < (float)Value) //値が閾値を越えたらエラー
                                return DIAG_THRESULT_ERR;
                            return DIAG_THRESULT_OK;            //それ以外はOK
                        }
                        break;
                    case EGDEFINE.egTagDataType.Boolean:
                    case EGDEFINE.egTagDataType.SByte:
                    case EGDEFINE.egTagDataType.Byte:
                    case EGDEFINE.egTagDataType.Int16:
                    case EGDEFINE.egTagDataType.UInt16:
                    case EGDEFINE.egTagDataType.Int32:
                    case EGDEFINE.egTagDataType.Int64:
                    case EGDEFINE.egTagDataType.Double:
                    case EGDEFINE.egTagDataType.String:
                    default:
                        break;
                }
                return DIAG_THRESULT_NOTCHECK;
            }

            /// <summary>
            /// 閾値チェック
            /// </summary>
            /// <param name="TargetValue"></param>
            /// <returns></returns>
            public SByte CheckTH(object TargetValue)
            {

                if (IsTargetIsBig == DIAG_THMODE_BIG)           //大きい場合のチェック
                    return CheckTH_Big(TargetValue);
                else if (IsTargetIsBig == DIAG_THMODE_SMALL)    //小さい場合のチェック
                    return CheckTH_Small(TargetValue);
                else
                    return DIAG_THRESULT_NOTCHECK;              //未定義
            }
            ///// <summary>
            ///// float型の閾値
            ///// </summary>
            //private float _flValue = 0;
            //public float flValue
            //{
            //    set
            //    {
            //        _flValue = value;
            //        service.EGAPI.EgTagWrite(TagName, value);
            //    }
            //    get { return _flValue; }
            //}
            ///// <summary>
            ///// UInt32型の閾値
            ///// </summary>
            //private UInt32 _Ui32Value = 0;
            //public UInt32 Ui32Value
            //{
            //    set
            //    {
            //        _Ui32Value = value;
            //        service.EGAPI.EgTagWrite(TagName, value);
            //    }
            //    get { return _Ui32Value; }
            //}
            ///// <summary>
            ///// UInt64型の閾値
            ///// </summary>
            //private UInt64 _Ui64Value = 0;
            //public UInt64 Ui64Value
            //{
            //    set
            //    {
            //        _Ui64Value = value;
            //        service.EGAPI.EgTagWrite(TagName, value);
            //    }
            //    get { return _Ui64Value; }
            //}
        }
    }
}
