﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using RTedge;

namespace EgMReset
{
    public partial class EdgeService
    {
        //タグの定義
        public MntTagCls ServiceIndRun = null;　     // インジケータタグ".Run" : bool / Service Run indicator
        public MntTagCls ServiceIndStatus = null;　  // インジケータタグ".Status" : byte / Service Status indicator
        public MntTagCls ServiceIndError = null;　   // インジケータタグ".Error" : bool / Service Error indicator
        public MntTagCls ServiceIndLive = null;　    // インジケータタグ".Live" : UInt32 / Service Live counter indicator

        
        /// <summary>
        /// プロパティタグ
        /// </summary>
        public MntTagCls AutoRun = null;             // プロパティタグ".AutoRun" : bool 動作自動スタートの有効有無
        public MntTagCls Error = null;               // インジケータタグ".Error" : bool エラー状態の有効有無
        public MntTagCls ErrorID = null;             // インジケータタグ".ErrorID" UInt32 実行失敗時のエラーコード
        
        public MntTagCls Mode = null;               // プロパティタグ".Mode" byte 復旧機能用 モード
        public MntTagCls Reset_ScriptPath = null;   // プロパティタグ".ScriptPath" string 復旧機能 フェイルセーフスクリプトパス

        public class MntTagCls
        {
            public EGDEFINE.egTagDataType Type = EGDEFINE.egTagDataType.UNDEFINE;   //型
            public string TagName = ""; //Tag名
            //コンストラクタ
            public MntTagCls(string _name, EGDEFINE.egTagDataType _Type)
            {
                TagName = _name;//名前の設定
                Type = _Type;   //型の設定
                InitValue();    //値初期化
            }

            private object _Value = new object();
            public object Value //値
            {
                set
                {
                    switch (Type)   //型ごとに変換 対応しているのは現状3つの型のみ
                    {
                        case EGDEFINE.egTagDataType.UInt32:
                            _Value = (UInt32)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.UInt64:
                            _Value = (UInt64)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Float:
                            _Value = (float)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Boolean:
                            _Value = (bool)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.SByte:
                            _Value = (SByte)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Byte:
                            _Value = (byte)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Int16:
                            _Value = (Int16)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.UInt16:
                            _Value = (UInt16)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Int32:
                            _Value = (Int32)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Int64:
                            _Value = (Int64)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.Double:
                            _Value = (double)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        case EGDEFINE.egTagDataType.String:
                            _Value = (string)value;
                            service.EGAPI.EgTagWrite(TagName, _Value);
                            break;
                        default:
                            break;
                    }
                }
                get { return _Value; }
            }
            /// <summary>
            /// 値の初期化
            /// </summary>
            private void InitValue()
            {
                switch (Type)   //型ごとに変換 対応しているのは現状3つの型のみ
                {
                    case EGDEFINE.egTagDataType.UInt32:
                        _Value = (UInt32)0;
                        break;
                    case EGDEFINE.egTagDataType.UInt64:
                        _Value = (UInt64)0;
                        break;
                    case EGDEFINE.egTagDataType.Float:
                        _Value = (float)0;
                        break;
                    case EGDEFINE.egTagDataType.Boolean:
                        _Value = (bool)false;
                        break;
                    case EGDEFINE.egTagDataType.SByte:
                        _Value = (SByte)0;
                        break;
                    case EGDEFINE.egTagDataType.Byte:
                        _Value = (byte)0;
                        break;
                    case EGDEFINE.egTagDataType.Int16:
                        _Value = (Int16)0;
                        break;
                    case EGDEFINE.egTagDataType.UInt16:
                        _Value = (UInt16)0;
                        break;
                    case EGDEFINE.egTagDataType.Int32:
                        _Value = (Int32)0;
                        break;
                    case EGDEFINE.egTagDataType.Int64:
                        _Value = (Int64)0;
                        break;
                    case EGDEFINE.egTagDataType.Double:
                        _Value = (double)0;
                        break;
                    case EGDEFINE.egTagDataType.String:
                        _Value = (string)"";
                        break;
                    default:
                        break;
                }
            }
        }
    }
}
