﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Diagnostics;

namespace EgMReset
{
    public class Reset
    {
        private EdgeService EGS = EdgeService.GetInstance();// RT-edgeのコード
        /// <summary>
        /// Gatherクラスの初期化
        /// </summary>
        public Reset()
        {
            //何かあれば
        }
        public void Execute(int mode, string ScriptPath)
        {
            try
            {
                //実行 exe呼び出し 非同期
                string argMode = "";
                string argScriptPath = "";

                argMode = "-m=" + mode.ToString();

                if (ScriptPath.Length > 0)
                    argScriptPath = "-f=\"" + @ScriptPath + "\"";

                //実行 exe 呼び出し 非同期
                Process proc = new Process();
                proc.StartInfo.FileName = "MtnReset.exe";
                proc.StartInfo.Arguments = argMode + " " + argScriptPath;
                proc.EnableRaisingEvents = true;
                proc.Exited += new EventHandler(proc_Exited);
                bool ret = proc.Start();
                if (ret == false)
                {
                    EGS.SetErrorID(CDefine.ERR_NOT_START_PROCESS);
                    EGS.PrintLog("ERR", "MtnReset.exe の起動に失敗しました。 ファイルが存在するか確認してください");
                }
            }
            catch (Exception ex)
            {
                EGS.PrintLog("ERR", "FATAL ERROR : {0}", System.Reflection.MethodBase.GetCurrentMethod().Name + " : " + ex.Message);
            }
        }
        public void proc_Exited(object sender, EventArgs e)
        {
            ///this.Invoke(evt);
        }
    }
}
