﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
///---------------------------------------------------------------------------------
/// Common.cs 共通関数等記載ファイル
///---------------------------------------------------------------------------------
using System;
using System.IO;
using System.Runtime.CompilerServices;

namespace MtnGather
{
    /// <summary>
    /// 定義
    /// </summary>
    public static partial class CDefine
    {
        //エラーコード
        public const uint SUCCESS = 0x00000000;                 //成功
        //public const uint ERR_LISTFILE = 0x00000010;            //リストファイルが無効


        public const uint ERR_FATAL_ERROR = 0xffffffff;         //システムエラー

        //DBG1コード定義
        //public static readonly uint API_Err = 0x1000;                   //APIエラー
        //public static readonly uint StartupArg = 0x2000;                   //起動引数コード
        //public static readonly uint INIFile = 0x4000;                   //iniファイル読込みコード
        //public static readonly uint TryCatch_Err = 0x5000;                  //TryCatchエラー
        //public static readonly uint INFO = 0x9000;                          //デバッグ情報

        //try-catch エラー
        public const uint ERR_TRY_CATCH = 0x00010000;           //try-catchでのエラー

    }
    /// <summary>
    /// 共通関数
    /// </summary>
    public class CommonFunc
    {
        /// <summary>
        /// 実行中の行数取得(呼び出し元の行番号返却)
        /// </summary>
        /// <param name="line"></param>
        /// <returns></returns>
        public static UInt16 GetLine([CallerLineNumber]int line = 0)
        {
            ushort uiLine;

            if (UInt16.TryParse(line.ToString(), out uiLine) == false)
            {
                uiLine = 0;
            }
            return uiLine;
        }

        /// <summary>
        /// 実行中のファイルネーム取得(呼び出し元のファイルパスを取得し、ファイルネームを返却)
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public static string GetFileName([CallerFilePath]string path = "")
        {
            return Path.GetFileName(path);
        }
    }
}
